NHORISZCLR  equ 10   ;number of horizontal color

    MAC EOR_LOGIC
EorKernel
DeltaBaseA equ * - EorKernel + ramkernel + 1
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    eor #02
    sta COLUBK
    rts

KERNELSIZE  equ *-EorKernel

EorPlasmaLogic
    ;copy kernel to RAM
    ldx #KERNELSIZE-1
CopyKernel
    lda EorKernel,X
    sta ramkernel,X
    dex
    bpl CopyKernel

    lda measure
    lsr
    asr #%110
    beq DoneHoriz       ;default hirozontal function
    cmp #2
    bne SineHoriz

    ;put a 4 in half of the EOR #2's
    ldx #4*NHORISZCLR-4
    ldy #4
PutHoriz4s
    sty DeltaBaseA,X
    txa
    sec
    sbc #8
    tax
    bpl PutHoriz4s
    bmi DoneHoriz

SineHoriz
    ldx #0
    stx temp
LoadHorizClr
    txa
    clc
    adc frame
    asr #$7F
    tay
    lda SinTab,Y
    lsr
    lsr
    sta temp+1
    eor temp
    sta DeltaBaseA,X
    lda temp+1
    sta temp
    inx
    inx
    inx
    inx
    cpx #4*NHORISZCLR
    bcc LoadHorizClr
DoneHoriz

    lda measure
    and #%00111100
    cmp #14*4
    bcc NormalYTab

    ;boring area - copy $80 to ytab!
    lda measure
    asl
    asl
    and #%00010000
    ora #%01000000
    sta temp
    ldx #EORKERNELSZ-1
LoadBogusYtab
    lsr
    adc $80,X
    and #%00101111
    ora temp
    sta ytab,X
    dex
    bpl LoadBogusYtab
    bmi DoneVert

NormalYTab
    lda measure
    asl
    asl
    and #$F0
    sta temp

    ldx #EORKERNELSZ-1
LoadYtab
    txa
    clc
    adc frame
    asr #$7F
    tay
    txa
    adc SinTab,Y
    asl
    asl
    adc frame
    lsr
    lsr
    tay
    lda SinTab,Y
    lsr
    lsr
    ora temp
    sta ytab,X
    dex
    bpl LoadYtab
DoneVert

    ldx #EORKERNELSZ
    lda measure
    cmp #WIPEMEASURE+1
    bcs NoWipe
    ldy looping
    bne NoWipe

    cmp #WIPEMEASURE
    bcs WipingIn

    ;hold it
    ldx #0
    beq NoWipe
WipingIn
    lda tempoCount
    cmp #TEMPODELAY/2
    lda beat
    rol
    cmp #EORKERNELSZ
    bcs NoWipe
    tax
NoWipe
    stx wipe

    ldx #0
    lda looping
    beq NoSlant2
    lda measure
    asr #2
    cmp #1
    bne NoSlant2
    tax
NoSlant2
    stx slant

    lda #$F0
    sta PF0
    lda #1
    sta CTRLPF
    lda #0
    sta COLUPF

    rts
    ENDM

    MAC EOR_KERNEL
EorPlasmaKernel
    lda wipe
    bne WipeOK
    sta WSYNC
    rts

WipeOK
    sec
    sbc slant
    sta temp        ;stop value for lower part
    sec
    sbc #1          ;start value for upper parts
    ldx #0          ;start value for lower part
    cpy #0
    sta WSYNC
    beq Normal
    bne EorKernelLoop2

Normal
    tax

EorKernelLoop
    lda ytab,X
    sta COLUBK
    jsr ramkernel

    lda slant       ;TODO: delay 1cy via lda.w $00FF,Y with Y = slant (0 or 1)?
    bne Slanting
Slanting
    CHECK_ALIGN Slanting

    lda ytab,X
    sta COLUBK
    jsr ramkernel

    SLEEP 4

    dex
    bpl EorKernelLoop
    CHECK_ALIGN EorKernelLoop
    bmi CheckSlant

EorKernelLoop2
    lda ytab,X
    sta COLUBK
    jsr ramkernel

    lda slant
    bne Slanting2
Slanting2
    CHECK_ALIGN Slanting2

    lda ytab,X
    sta COLUBK
    jsr ramkernel

    inx
    cpx.w temp
    bne EorKernelLoop2
    CHECK_ALIGN EorKernelLoop2

CheckSlant
    lda slant
    beq NoSlant
    sta WSYNC
    sta WSYNC
NoSlant

    lda #0
    sta COLUBK

    rts
    ENDM
